﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Sierpinski
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Depth of the fractal
        /// </summary>
        private int depth = 5;


        /*******************************************
         * Events
         * 
         */
        public Form1()
        {
            InitializeComponent();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            label1.Text = "Depth: " + trackBar1.Value;
            depth = trackBar1.Value;
            panel1.Invalidate();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            BufferedGraphics bg = BufferedGraphicsManager.Current.Allocate(e.Graphics, e.ClipRectangle);
            Graphics g = bg.Graphics;
            g.Clear(Color.White);

            drawSierpinski(new Point(0, 0), new Point(500, 0), new Point(250, 433), depth, g);

            bg.Render();
            bg.Dispose();
        }


        /*******************************************
        * Drawings
        * 
        */

        /// <summary>
        /// A black pen for drawing
        /// </summary>
        private static Pen pen = new Pen(Color.Black);

        /// <summary>
        /// Draw a triangle in the given graphic
        /// </summary>
        /// <param name="a">first vertex of the triangle</param>
        /// <param name="b">second vertex of the triangle</param>
        /// <param name="c">third vertex of the triangle</param>
        /// <param name="g">the graphic</param>
        private void drawTriangle(Point a, Point b, Point c, Graphics g)
        {
            // A compléter
        }

        /// <summary>
        /// Draw a Sierpinski triangle at the given location to the given depth
        /// </summary>
        /// <param name="a">first vertex of the triangle</param>
        /// <param name="b">second vertex of the triangle</param>
        /// <param name="c">third vertex of the triangle</param>
        /// <param name="depth">recursion depth</param>
        /// <param name="g">the graphics</param>
        private void drawSierpinski(Point a, Point b, Point c, int depth, Graphics g)
        {
           // A compléter
        }


    }
}
